
#include <windows.h>

//Spool Metafile constants
#define SPLMETA_SIGNATURE  0x00010000
//Spool Metafile record types
#define SPL_RESERVED_1     0x00000001  //  1
#define SPL_RESERVED_2     0x00000002  //  2
#define SPL_RESERVED_3     0x00000003  //  3
#define SPL_RESERVED_4     0x00000004  //  4
#define SPL_RESERVED_5     0x00000005  //  5
#define SPL_RESERVED_6     0x00000006  //  6
#define SPL_RESERVED_7     0x00000007  //  7
#define SPL_RESERVED_8     0x00000008  //  8
#define SPL_RESERVED_9     0x00000009  //  9
#define SPL_RESERVED_10    0x0000000A  // 10
#define SPL_RESERVED_11    0x0000000B  // 11
#define SPL_EMFFILE       0x0000000C  // 12
#define SPL_SMRDATASIZE    0x0000000D  // 13
#define SPL_SMRDATASIZE_PAD    0x0000000E  // 14

/*
 * It seems that this header is exactly like the 
 * SMR DATASIZE header.
 *
 * However interpretation of the results, is a bit difficult, yet.
 *
 */

typedef struct tagSPLMETAHEADER {
    DWORD SIGNATURE;
    DWORD nSize;    // header size
    DWORD unknown1; // maybe offset of Job Title from start

                    // FF: no, most probably that is like nSize 
		    // in SMR DATASIZE, previous data = 0, sizeof header=16
		    //  => unknown1=16;

    DWORD unknown2; // FF: Like Unknown in SMR DATASIZE and so always 0.

    //CHAR  Data[1];  // Job Title
} SPLMETAHEADER, *PSPLMETAHEADER;
 
// Base record type for the Spool Metafile.
typedef struct tagSPL
{
    DWORD   iType;  // Spool metafile record type
    DWORD   nSize;  // length of the following data
                    // not including this header
                    // This must be a multiple of 4.
} SMR, *PSMR;

typedef struct tagSMREMFFILE
{
    SMR     smr;
    //BYTE    Data[1];
} SMREMFFILE, *PSMREMFFILE;
 
typedef struct tagSMRDATASIZE
{
    SMR     smr;
    DWORD   nSize;   // Size of the preceding data 
                     // including size of preceding header.
    DWORD   Unknown; // 0
} SMRDATASIZE, *PSMRDATASIZE;
